use super::*;

hid_report_descriptor!(DESCRIPTOR,
    USAGE_PAGE, U_DESKTOP,
    USAGE, US_GAMEPAD,
    COLLECTION, COLLECTION_APPLICATION,
        REPORT_ID, 1,

        USAGE_PAGE, U_BUTTON,
        USAGE_MIN, 1,
        USAGE_MAX, 8,
        LOGICAL_MIN, 0,
        LOGICAL_MAX, 1,
        REPORT_SIZE, 1,
        REPORT_COUNT, 8,
        INPUT, DATA|VAR|ABS,

        USAGE_PAGE, U_DESKTOP,
        USAGE, US_X,
        USAGE, US_Y,
        LOGICAL_MIN, 0x81,
        LOGICAL_MAX, 0x7f,
        REPORT_SIZE, 8,
        REPORT_COUNT, 2,
        INPUT, DATA|VAR|ABS,
    END_COLLECTION,
);

#[derive(Clone, Copy, PartialEq, Default)]
pub struct Gamepad {
    pub x:i8,
    pub y:i8,
    pub buttons :u8,
}
impl Report for Gamepad {
    fn descriptor() -> &'static [u8] { &DESCRIPTOR }
    fn report(&mut self, id:u8, buffer:&mut [u8]) -> usize
    {
        match id {
            1 => copy_buffer(buffer, [
                id,
                self.buttons,
                self.x as u8,
                self.y as u8,
            ]),
            _ => 0,
        }
    }
}
