use super::*;

mod mouse; pub use mouse::Mouse;
mod gamepad; pub use gamepad::Gamepad;

pub trait Report {
    fn descriptor() -> &'static [u8];
    fn report(&mut self, id:u8, data:&mut [u8]) -> usize;
}

fn copy_buffer<const N:usize>(buffer:&mut [u8], data:[u8;N]) -> usize
{
    for i in 0..N {
        buffer[i] = data[i];
    }
    N
}
